local aUF = LibStub("AceAddon-3.0"):GetAddon("ag_UnitFrames")
local aUF_combopoints = aUF:NewModule("Combopoints")
aUF_combopoints.inherit = "target"
local newFrame, delFrame = aUF.newFrame, aUF.delFrame

function aUF_combopoints:OnRegisterEvents(object)
	if self:IsEnabled() then
		object:ObjectRegisterEvent("PLAYER_COMBO_POINTS","UpdateComboPoints")
	else
		object:ObjectUnregisterEvent("PLAYER_COMBO_POINTS","UpdateComboPoints")
	end
end

function aUF_combopoints:OnParseLayout(object)
	if not object.Combo1 then
		for i=1,5 do
			local frame = "Combo" .. i
			object[frame] = newFrame("Texture", object.top, "OVERLAY")
			object[frame]:SetTexture("Interface\\AddOns\\ag_UnitFrames\\images\\combo.tga")
			object[frame]:SetHeight(10)
			object[frame]:SetWidth(10)
			object[frame]:Hide()
			if i > 1 then
				object[frame]:SetPoint("BOTTOMRIGHT",object["Combo"..i-1],"BOTTOMLEFT")
			else
				object[frame]:SetPoint("BOTTOMRIGHT",object.frame,"BOTTOMRIGHT",-2,-1)
			end
		end
	end
end

function aUF_combopoints:OnDisable(object)
	for _,object in pairs(aUF.units) do
		if self.inherit == object.inherit then
			if object.Combo1 then
				object.Combo1 = delFrame(object.Combo1)		
				object.Combo2 = delFrame(object.Combo2)		
				object.Combo3 = delFrame(object.Combo3)		
				object.Combo4 = delFrame(object.Combo4)		
				object.Combo5 = delFrame(object.Combo5)		
				self:OnRegisterEvents(object)
			end
		end
	end
end

function aUF_combopoints:OnEnable()
	for _,object in pairs(aUF.units) do
		if object.type then
			if self.inherit == object.inherit then
				self:OnParseLayout(object)
				if object.unit then
					object:UpdateComboPoints()
					self:OnRegisterEvents(object)
				end
			end
		end
	end
end

function aUF_combopoints:OnUpdateAll(object)
	object:UpdateComboPoints()
end

-------------------
-- CLASS METHODS --
-------------------

function aUF.classes.aUFunitCombo.prototype:UpdateComboPoints()
	local points = GetComboPoints()
	if self.Combo1 then
		for i=0,4 do
			if points > i then
				self["Combo"..i+1]:Show()
			else
				self["Combo"..i+1]:Hide()
			end
		end
	else
		if points == 0 then
			points = ""
		end
	end
end