local aUF = LibStub("AceAddon-3.0"):GetAddon("ag_UnitFrames")
local aUF_highlight = aUF:NewModule("Highlight")
local newFrame, delFrame = aUF.newFrame, aUF.delFrame

function aUF_highlight:OnRegister()
	self:RegisterDefaults({
		units = {
			["**"] = {
				HighlightSelected = true
			}
		}
	})	
end

function aUF_highlight:OnRegisterEvents(object)
	if object.database.HighlightSelected and self:IsEnabled() then
		object:ObjectRegisterEvent("PLAYER_TARGET_CHANGED","UpdateHighlight")
	else
		object:ObjectUnregisterEvent("PLAYER_TARGET_CHANGED","UpdateHighlight")
	end
end

function aUF_highlight:OnDisableObject(object)
	
end

function aUF_highlight:OnEnable()
	for _,object in pairs(aUF.units) do
		if object.type then	
			self:OnParseLayout(object)	
			object:UpdateHighlight()	
			if object.unit then
				self:OnRegisterEvents(object)
			end
		end
	end
end

function aUF_highlight:OnDisable()
	for _,object in pairs(aUF.units) do
		if object.highlight then
			object.highlight = delFrame(object.highlight)		
			self:OnRegisterEvents(object)
		end
	end
end

function aUF_highlight:OnUpdateAll(object)
	object:UpdateHighlight()
end

function aUF_highlight:OnEnter(object)
	object:UpdateHighlight(nil, true)
end

function aUF_highlight:OnLeave(object)
	object:UpdateHighlight()
end

function aUF_highlight:OnParseLayout(object)
	if object.database.HighlightSelected and not object.highlight then
		local highlight = newFrame("Texture",object.top, "OVERLAY")
		highlight:SetAlpha(0.5)
		highlight:SetTexture("Interface\\QuestFrame\\UI-QuestTitleHighlight")
		highlight:SetBlendMode("ADD")	
		highlight:SetPoint("TOPLEFT",object.frame, "TOPLEFT", 5, -5)
		highlight:SetPoint("BOTTOMRIGHT",object.frame, "BOTTOMRIGHT", -5, 5)
		highlight:Hide()
		object.highlight = highlight
	end
end

	
function aUF.classes.aUFunit.prototype:UpdateHighlight(event, entered)
	if self.unit and (UnitExists("target") and UnitIsUnit("target",self.unit) and not (self.unit:find("target")) and self.database.HighlightSelected == true) or (entered and self.database.HighlightSelected == true) then
		self.highlight:Show()
	elseif self.highlight then
		self.highlight:Hide()
	end
end