local aUF = LibStub("AceAddon-3.0"):GetAddon("ag_UnitFrames")
local aUF_leadericon = aUF:NewModule("Leadericon")
local newFrame, delFrame = aUF.newFrame, aUF.delFrame

function aUF_leadericon:OnRegister()
	self:RegisterDefaults({
		units = {
			["**"] = {
				showLeaderIcon = true,
			},		
		}
	})
end

function aUF_leadericon:OnRegisterEvents()
end

function aUF_leadericon:RegisterEvents(object)
	if self:IsEnabled() and object.database.showLeaderIcon then
		object:ObjectRegisterEvent("PARTY_LEADER_CHANGED", "LabelsCheckLeader")
	else
		object:ObjectUnregisterEvent("PARTY_LEADER_CHANGED", "LabelsCheckLeader")
	end
end

function aUF_leadericon:DisableObject(object)

end

function aUF_leadericon:OnUpdateAll(object)
	object:UpdateLeaderIcon()
end

function aUF_leadericon:OnMetroUpdate(object)
	object:UpdateLeaderIcon()
end

function aUF_leadericon:OnRosterUpdate(object)
	object:UpdateLeaderIcon()
end

function aUF_leadericon:OnEnable()
	for _,object in pairs(aUF.units) do
		if object.type then	
			object:ApplyLayout()
			if object.unit then	
				object:UpdateLeaderIcon()
				self:OnRegisterEvents(object)
			end
		end
	end
end

function aUF_leadericon:OnDisable()
	for _,object in pairs(aUF.units) do
		if object.type then
			if object.icons.leaderIcon then
				object.icons.leaderIcon = delFrame(object.icons.leaderIcon)		
				self:OnRegisterEvents(object)
				object:ApplyLayout()
			end
		end
	end
end

function aUF_leadericon:OnParseLayout(object)
	if not object.icons.leaderIcon then
		object.icons.leaderIcon = newFrame("Texture", object.top, "OVERLAY")
		object.icons.leaderIcon:SetTexture("Interface\\GroupFrame\\UI-Group-LeaderIcon")
	end
end

function aUF.classes.aUFunit.prototype:UpdateLeaderIcon()
	if self.database.showLeaderIcon then
		if self.type == "raid" then
			local _, rank = GetRaidRosterInfo(self.number)
			if rank == 2 then
				self.icons.leaderIcon:Show()
				return
			end
		elseif self.type == "party" and tonumber(GetPartyLeaderIndex()) == tonumber(self.number) then
			self.icons.leaderIcon:Show()
			return
		elseif self.unit == "player" and IsPartyLeader() then
			self.icons.leaderIcon:Show()
			return
		end
	end
	self.icons.leaderIcon:Hide()
end