local aUF = LibStub("AceAddon-3.0"):GetAddon("ag_UnitFrames")
local aUF_masterlootericon = aUF:NewModule("Masterlootericon")
local newFrame, delFrame = aUF.newFrame, aUF.delFrame

function aUF_masterlootericon:OnRegister()
	self:RegisterDefaults({
		units = {
			["**"] = {
				looterIcon = true,
			},		
		}
	})
end

function aUF_masterlootericon:OnRegisterEvents(object)
	if self:IsEnabled() and object.database.looterIcon then
		object:ObjectRegisterEvent("PARTY_LOOT_METHOD_CHANGED", "UpdateMasterLooterIcon")
	else
		object:ObjectUnregisterEvent("PARTY_LOOT_METHOD_CHANGED", "UpdateMasterLooterIcon")	
	end
end

function aUF_masterlootericon:DisableObject(object)
	self[object] = nil
end

function aUF_masterlootericon:OnUpdateAll(object)
	object:UpdateMasterLooterIcon()
end

function aUF_masterlootericon:OnMetroUpdate(object)
	object:UpdateMasterLooterIcon()
end

function aUF_masterlootericon:OnRosterUpdate(object)
	object:UpdateMasterLooterIcon()
end

function aUF_masterlootericon:OnEnable()
	for _,object in pairs(aUF.units) do
		if object.type then
			object:ApplyLayout()
			if object.unit then
				object:UpdateMasterLooterIcon()
				self:OnRegisterEvents(object)
			end
		end
	end
end

function aUF_masterlootericon:OnDisable()
	for _,object in pairs(aUF.units) do
		if object.type then
			if object.icons.looterIcon then
				object.icons.looterIcon = delFrame(object.icons.looterIcon)		
				self:OnRegisterEvents(object)
				object:ApplyLayout()
			end
		end
	end
end

function aUF_masterlootericon:OnParseLayout(object)
	if not object.icons.looterIcon then
		object.icons.looterIcon = newFrame("Texture", object.top, "OVERLAY")
		object.icons.looterIcon:SetTexture("Interface\\GroupFrame\\UI-Group-MasterLooter")
	end
end

function aUF.classes.aUFunit.prototype:UpdateMasterLooterIcon()
	if self.database.looterIcon == true and self.number then
		local lootMaster
		if self.type == "raid" then
			lootMaster = select(11, GetRaidRosterInfo(self.number))
			if lootMaster then
				self.icons.looterIcon:Show()
				return
			end
		else
			_, lootMaster = GetLootMethod()
			if lootMaster then
				if self.unit == "player" and lootMaster == 0 then
					self.icons.looterIcon:Show()
					return
				elseif self.type == "party" and lootMaster > 0 then
					if lootMaster == self.number then
						self.icons.looterIcon:Show()
						return
					end
				end
			end
		end
	end
	self.icons.looterIcon:Hide()
end