local aUF = LibStub("AceAddon-3.0"):GetAddon("ag_UnitFrames")
local aUF_pvpicon = aUF:NewModule("Pvpicon")
local newFrame, delFrame = aUF.newFrame, aUF.delFrame

function aUF_pvpicon:OnRegister()
	self:RegisterDefaults({
		units = {
			["**"] = {
				pvpIcon = true,
			},		
		}
	})
end

function aUF_pvpicon:OnRegisterEvents(object)
	if self:IsEnabled() and object.database.pvpIcon then
		object:ObjectRegisterEvent("UPDATE_FACTION", "UpdatePvPIcon")
		object:ObjectRegisterEvent("PLAYER_FLAGS_CHANGED", "UpdatePvPIcon")
		object:ObjectRegisterEvent("UNIT_FACTION", "UpdatePvPIcon")
	else
		object:ObjectUnregisterEvent("UPDATE_FACTION", "UpdatePvPIcon")
		object:ObjectUnregisterEvent("PLAYER_FLAGS_CHANGED", "UpdatePvPIcon")
		object:ObjectUnregisterEvent("UNIT_FACTION", "UpdatePvPIcon")	
	end
end

function aUF_pvpicon:DisableObject(object)
end

function aUF_pvpicon:OnUpdateAll(object)
	object:UpdatePvPIcon()
end

function aUF_pvpicon:OnMetroUpdate(object)
	object:UpdatePvPIcon()
end

function aUF_pvpicon:OnRosterUpdate(object)
	object:UpdatePvPIcon()
end

function aUF_pvpicon:OnEnable()
	for _,object in pairs(aUF.units) do
		if object.type then
			object:ApplyLayout()
			if object.unit then
				object:UpdatePvPIcon()
				self:OnRegisterEvents(object)
			end
		end
	end
end

function aUF_pvpicon:OnDisable()
	for _,object in pairs(aUF.units) do
		if object.type then
			if object.icons.pvpIcon then
				object.icons.pvpIcon = delFrame(object.icons.pvpIcon)		
				self:OnRegisterEvents(object)
				object:ApplyLayout()
			end
		end
	end
end

function aUF_pvpicon:OnParseLayout(object)
	if not object.icons.pvpIcon then
		object.icons.pvpIcon = newFrame("Texture", object.top, "OVERLAY")
	end
end
	
function aUF.classes.aUFunit.prototype:UpdatePvPIcon()
	if self.database.pvpIcon then
		if ( UnitIsPVPFreeForAll(self.unit) ) then
			self.icons.pvpIcon:SetTexture("Interface\\TargetingFrame\\UI-PVP-FFA")
			self.icons.pvpIcon:Show()
			return
		elseif ( UnitFactionGroup(self.unit) and UnitIsPVP(self.unit) ) then
			self.icons.pvpIcon:SetTexture("Interface\\TargetingFrame\\UI-PVP-"..UnitFactionGroup(self.unit))
			self.icons.pvpIcon:Show()
			return
		end
	end
	self.icons.pvpIcon:Hide()
end