local aUF = LibStub("AceAddon-3.0"):GetAddon("ag_UnitFrames")
local aUF_raidtargeticon = aUF:NewModule("Raidtargeticon")
local newFrame, delFrame = aUF.newFrame, aUF.delFrame

function aUF_raidtargeticon:OnRegister()
	self:RegisterDefaults({
		units = {
			["**"] = {
				raidIcon = true,
			},		
		}
	})
end

function aUF_raidtargeticon:OnRegisterEvents(object)
	if self:IsEnabled() and object.database.raidIcon then
		object:ObjectRegisterEvent("RAID_TARGET_UPDATE", "UpdateRaidTargetIcon")
	else
		object:ObjectUnregisterEvent("RAID_TARGET_UPDATE", "UpdateRaidTargetIcon")	
	end
end

function aUF_raidtargeticon:DisableObject(object)
end

function aUF_raidtargeticon:OnUpdateAll(object)
	object:UpdateRaidTargetIcon()
end

function aUF_raidtargeticon:OnMetroUpdate(object)
	object:UpdateRaidTargetIcon()
end

function aUF_raidtargeticon:OnRosterUpdate(object)
	object:UpdateRaidTargetIcon()
end

function aUF_raidtargeticon:OnEnable()
	for _,object in pairs(aUF.units) do
		if object.type then
			object:ApplyLayout()
			if object.unit then
				object:UpdateRaidTargetIcon()
				self:OnRegisterEvents(object)
			end
		end
	end
end

function aUF_raidtargeticon:OnDisable()
	for _,object in pairs(aUF.units) do
		if object.type then
			if object.icons.raidTargetIcon then
				object.icons.raidTargetIcon = delFrame(object.icons.raidTargetIcon)		
				self:OnRegisterEvents(object)
				object:ApplyLayout()
			end
		end
	end
end

function aUF_raidtargeticon:OnParseLayout(object)
	if not object.icons.raidTargetIcon then
		object.icons.raidTargetIcon = newFrame("Texture", object.top, "OVERLAY")
		object.icons.raidTargetIcon:SetTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcons")
	end
end

function aUF.classes.aUFunit.prototype:UpdateRaidTargetIcon()
	local index
	if self.unit then
		index = GetRaidTargetIndex(self.unit)
	end
	if ( index ) and UnitExists(self.unit) and self.database.raidIcon then
		SetRaidTargetIconTexture(self.icons.raidTargetIcon, index)
		self.icons.raidTargetIcon:Show()		
	else
		self.icons.raidTargetIcon:Hide()
	end
end